import os

from flask import (Blueprint, abort, current_app, flash, redirect,
                   render_template, request, send_from_directory, url_for)

from yadc.models import IMAGE_STORE

bp = Blueprint('main', __name__)

@bp.route('/')
def index():
    return redirect(url_for('post.posts'))

@bp.route('/i/<path:path>')
def uploaded_img(path, store=IMAGE_STORE.image, exten=None):
    ext = os.path.splitext(path)[1]

    if exten is not None and ext.split('.')[1] != exten:
        abort(404)

    filename = path.split('/')[0].split('.')[0]
    # print(os.path.join(current_app.config.get('POST_UPLOADS'), store, "{}{}".format(filename, ext)))
    return send_from_directory(
        os.path.join(current_app.config.get('POST_UPLOADS'), store.value),
        f"{filename}{ext}"
    )

@bp.route('/jpeg/<path:path>')
def uploaded_jpeg(*args, **kwargs):
    return uploaded_img(*args, **kwargs, store=IMAGE_STORE.jpeg, exten='jpg')

@bp.route('/sample/<path:path>')
def uploaded_sample(*args, **kwargs):
    return uploaded_img(*args, **kwargs, store=IMAGE_STORE.sample, exten='jpg')

@bp.route('/bigthumb/<path:path>')
def uploaded_big_thumb(*args, **kwargs):
    return uploaded_img(*args, **kwargs, store=IMAGE_STORE.thumb_big, exten='jpg')

@bp.route('/thumb/<path:path>')
def uploaded_smol_thumb(*args, **kwargs):
    return uploaded_img(*args, **kwargs, store=IMAGE_STORE.thumb_smol, exten='jpg')
