
#https://stackoverflow.com/questions/1094841/reusable-library-to-get-human-readable-version-of-file-size
def sizeof_fmt(num, suffix='B'):
    for unit in ['','Ki','Mi','Gi','Ti','Pi','Ei','Zi']:
        if abs(num) < 1024.0:
            return "%3.1f%s%s" % (num, unit, suffix)
        num /= 1024.0
    return "%.1f%s%s" % (num, 'Yi', suffix)

from flask import request
from werkzeug.urls import Href

# def query_replace(dic, base=''):
#     args = request.args.to_dict()
#     return Href(base)(args.update(dic) or args)
def query_replace(dic, base=''):
    args = request.args.to_dict()
    args.update(dic)
    return Href(base)({k:v for k,v in args.items() if v})

from flask import session

def session_rating():
    rating = session.get('enforced_rating')
    if rating and rating != 'safe':
        return dict(rating=rating)
    return dict()

def tag_reference(tag=None):
    tags = request.args.get('tags', '').split()
    if tag:
        if tag in tags:
            tags.remove(tag)
        else:
            tags.append(tag)
    return ' '.join(tags)

def tag_endpoint(tag):
    return query_replace(
        dict(**session_rating(), tags=tag_reference(tag)),
        url_for('post.posts')
    )

from flask import request, url_for
from werkzeug.urls import url_parse

def nextpage():
    nextpg = request.args.get('next')
    if not nextpg or url_parse(nextpg).netloc != '':
        nextpg = url_for('main.index')
    return nextpg

from flask import flash

def flasherrors(form):
    for key,errs in form.errors.items():
        label = form.__getattribute__(key).label.text
        for err in errs:
            flash(f'{label}: {err}', category='error')